Index: /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ALTIX_NAUTILUS_MPT
===================================================================
--- /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ALTIX_NAUTILUS_MPT	(revision 8467)
+++ /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ALTIX_NAUTILUS_MPT	(revision 8468)
@@ -65,4 +65,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-IBM_EKMAN_INGV
===================================================================
--- /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-IBM_EKMAN_INGV	(revision 8467)
+++ /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-IBM_EKMAN_INGV	(revision 8468)
@@ -47,4 +47,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW6_CALYPSO
===================================================================
--- /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW6_CALYPSO	(revision 8467)
+++ /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW6_CALYPSO	(revision 8468)
@@ -43,4 +43,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: unk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW6_VARGAS
===================================================================
--- /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW6_VARGAS	(revision 8467)
+++ 	(revision )
@@ -1,79 +1,0 @@
-#!/bin/bash 
-#!
-# @ job_name = MPI_config
-# standard output file  
-# @ output = $(job_name).$(jobid)
-# standard error file
-# @ error =  $(job_name).$(jobid)
-# job type
-# @ job_type = parallel
-# Number of procs 
-# @ total_tasks = NPROCS
-# time
-# @ wall_clock_limit = 1:30:00
-# @ queue
-
-#
-# Test specific settings. Do not hand edit these lines; the fcm_job.sh script will set these
-# (via sed operating on this template job file). 
-#
-  OCEANCORES=NPROCS
-  export SETTE_DIR=DEF_SETTE_DIR
-
-###############################################################
-#
-# set up mpp computing environment
-#
-# Local settings for machine IBM Power6 (VARGAS at IDRIS France)
-#
-export MPIRUN="mpiexec -n $OCEANCORES"
-
-#
-# load sette functions (only post_test_tidyup needed)
-#
-  . ${SETTE_DIR}/all_functions.sh
-#
-
-# Don't remove neither change the following line
-# BODY
-
-#
-# These variables are needed by post_test_tidyup function in all_functions.sh
-#
-  export EXE_DIR=DEF_EXE_DIR
-  export INPUT_DIR=DEF_INPUT_DIR
-  export CONFIG_DIR=DEF_CONFIG_DIR
-  export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
-  export NEW_CONF=DEF_NEW_CONF
-  export CMP_NAM=DEF_CMP_NAM
-  export TEST_NAME=DEF_TEST_NAME
-#
-# end of set up
-###############################################################
-#
-# change to the working directory 
-#
-cd ${EXE_DIR}
-
-  echo Running on host `hostname`
-  echo Time is `date`
-  echo Directory is `pwd`
-# 
-#  Run the parallel MPI executable 
-#
-  echo "Running time ${MPIRUN} ./opa"
-#
-  if [ MPI_FLAG == "yes" ]; then
-     time ${MPIRUN} ./opa
-  else
-     time ./opa
-  fi
-
-#
-  post_test_tidyup
-
-# END_BODY
-# Don't remove neither change the previous line
-
-
-  exit
Index: /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW7_METO
===================================================================
--- /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW7_METO	(revision 8467)
+++ /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW7_METO	(revision 8468)
@@ -48,4 +48,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW7_MONSOON
===================================================================
--- /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW7_MONSOON	(revision 8467)
+++ /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW7_MONSOON	(revision 8468)
@@ -47,4 +47,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_ADA
===================================================================
--- /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_ADA	(revision 8467)
+++ /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_ADA	(revision 8468)
@@ -44,4 +44,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_ADA_DEBUG
===================================================================
--- /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_ADA_DEBUG	(revision 8467)
+++ /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_ADA_DEBUG	(revision 8468)
@@ -44,4 +44,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_ADA_O0
===================================================================
--- /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_ADA_O0	(revision 8467)
+++ /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_ADA_O0	(revision 8468)
@@ -45,4 +45,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_CURIE
===================================================================
--- /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_CURIE	(revision 8467)
+++ /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_CURIE	(revision 8468)
@@ -45,4 +45,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_MOBILIS
===================================================================
--- /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_MOBILIS	(revision 8467)
+++ /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_MOBILIS	(revision 8468)
@@ -42,4 +42,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: unk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_TITANE
===================================================================
--- /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_TITANE	(revision 8467)
+++ 	(revision )
@@ -1,72 +1,0 @@
-#!/bin/bash 
-#!
-#MSUB -T 3600                # Limite de temps elapsed du job ici 3600s
-#MSUB -r SETTE_JOB           # Nom du job                
-#MSUB -n NPROCS              # Reservation de NPROCS(number of processus)
-##########################################################################
-#
-# Test specific settings. Do not hand edit these lines; the fcm_job.sh script will set these
-# (via sed operating on this template job file). 
-#
-  OCEANCORES=NPROCS
-  export SETTE_DIR=DEF_SETTE_DIR
-#
-# set up mpp computing environment
-#
-# Local settings for machine BULL (TITANE at CCRT France)
-#
-export MPIRUN="mpirun -np $OCEANCORES"
-
-#
-# load sette functions (only post_test_tidyup needed)
-#
-  . ${SETTE_DIR}/all_functions.sh
-#
-
-# modules to load
-module load netcdf
-
-# Don't remove neither change the following line
-# BODY
-
-#
-# These variables are needed by post_test_tidyup function in all_functions.sh
-#
-  export EXE_DIR=DEF_EXE_DIR
-  export INPUT_DIR=DEF_INPUT_DIR
-  export CONFIG_DIR=DEF_CONFIG_DIR
-  export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
-  export NEW_CONF=DEF_NEW_CONF
-  export CMP_NAM=DEF_CMP_NAM
-  export TEST_NAME=DEF_TEST_NAME
-#
-# end of set up
-###############################################################
-#
-# change to the working directory 
-#
-cd ${EXE_DIR}
-
-  echo Running on host `hostname`
-  echo Time is `date`
-  echo Directory is `pwd`
-# 
-#  Run the parallel MPI executable 
-#
-  if [ MPI_FLAG == "yes" ]; then
-  echo "Running time ${MPIRUN} ./opa"
-     time ${MPIRUN} ./opa
-  else
-  echo "Running time ./opa"
-     time ./opa
-  fi
-
-#
-  post_test_tidyup
-
-# END_BODY
-# Don't remove neither change the previous line
-
-
-  exit
-
Index: /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-XC40_METO
===================================================================
--- /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-XC40_METO	(revision 8467)
+++ /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-XC40_METO	(revision 8468)
@@ -40,4 +40,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-XC_ARCHER_INTEL
===================================================================
--- /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-XC_ARCHER_INTEL	(revision 8467)
+++ /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-XC_ARCHER_INTEL	(revision 8468)
@@ -50,4 +50,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ifort_athena
===================================================================
--- /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ifort_athena	(revision 8467)
+++ /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ifort_athena	(revision 8468)
@@ -43,4 +43,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ifort_athena_xios
===================================================================
--- /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ifort_athena_xios	(revision 8467)
+++ /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ifort_athena_xios	(revision 8468)
@@ -49,4 +49,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-macport_osx
===================================================================
--- /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-macport_osx	(revision 8467)
+++ /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-macport_osx	(revision 8468)
@@ -44,4 +44,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-macport_osx_debug
===================================================================
--- /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-macport_osx_debug	(revision 8467)
+++ /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-macport_osx_debug	(revision 8468)
@@ -44,4 +44,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-mpmd-ALTIX_NAUTILUS_MPT
===================================================================
--- /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-mpmd-ALTIX_NAUTILUS_MPT	(revision 8467)
+++ /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-mpmd-ALTIX_NAUTILUS_MPT	(revision 8468)
@@ -68,4 +68,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/sette_batch_template
===================================================================
--- /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/sette_batch_template	(revision 8467)
+++ /trunk/NEMOGCM/SETTE/BATCH_TEMPLATE/sette_batch_template	(revision 8468)
@@ -44,4 +44,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /trunk/NEMOGCM/SETTE/all_functions.sh
===================================================================
--- /trunk/NEMOGCM/SETTE/all_functions.sh	(revision 8467)
+++ /trunk/NEMOGCM/SETTE/all_functions.sh	(revision 8468)
@@ -172,4 +172,5 @@
 echo "COMPILER is : ${CMP_NAM}"
 echo "TEST is : ${TEST_NAME}"
+echo "TOOLS directory is : ${TOOLS_DIR}"
 ################################################################
 # SMALL DEBUG
Index: /trunk/NEMOGCM/SETTE/prepare_job.sh
===================================================================
--- /trunk/NEMOGCM/SETTE/prepare_job.sh	(revision 8467)
+++ /trunk/NEMOGCM/SETTE/prepare_job.sh	(revision 8468)
@@ -151,24 +151,4 @@
 fi
 ################################################################
-
-##########################################################################
-# COPY RESTART FILES (if needed; i.e. only for SHORT job in RESTART TESTS)
-# get the input tarfile if needed
-# SF : not ok for the moment because at this point is needed cn_exp variable,
-# SF : here it it not known.
-#\cd ${EXE_DIR}
-#if [ "$(echo ${TEST_NAME} | grep -c "SHORT" )" -ne 0 ] ; then
-#    for (( i=1; i<=${NB_PROC}; ${NB_PROC}++)) ; do
-#        L_NPROC=`printf "%04d\n" $i`
-#        ln -sf ../LONG/${NEW_CONF}_00000060_restart_${L_NPROC-1}.nc .
-#    done
-#fi
-## SF : other way
-##      for file in ../LONG/${NEW_CONF}_*restart_0*.nc ; do
-##              ncpu=`echo $file | awk -F '_' '{print $NF}' | cut -f 1 -d '.'`
-##              ln -sf ${file}  .
-##      done
-##fi
-##########################################################################
 
 ################################################################
@@ -309,4 +289,5 @@
              -e"s:DEF_EXE_DIR:${EXE_DIR}:" \
              -e"s:DEF_CONFIG_DIR:${CONFIG_DIR}:" \
+             -e"s:DEF_TOOLS_DIR:${TOOLS_DIR}:" \
              -e"s:MPI_FLAG:${MPI_FLAG}:" \
              -e"s:DEF_NEMO_VALIDATION:${NEMO_VALIDATION_DIR}:" -e"s:DEF_NEW_CONF:${NEW_CONF}:" \
Index: /trunk/NEMOGCM/SETTE/sette_rpt.sh
===================================================================
--- /trunk/NEMOGCM/SETTE/sette_rpt.sh	(revision 8467)
+++ /trunk/NEMOGCM/SETTE/sette_rpt.sh	(revision 8468)
@@ -1,3 +1,4 @@
 #!/bin/bash -f
+#set -vx
 #
 # simple SETTE report generator.
@@ -10,4 +11,69 @@
 ######################### Start of function definitions #################################
 ##
+
+function restfile() {
+# Rebuild ice restart for SAS CONFIG, and restartability checks. Expects LONG and SHORT run directories.
+# For Stand Alone Surface configuration ocean is not running, just run ice model; so no outputs ocean files.
+# Compares LONG rebuild restart ice file with equivalent entry from the SHORT rebuild restart ice file.
+#
+  vdir=$1
+  nam=$2
+  pass=$3
+#
+  if [ -d $vdir/$nam ]; then
+    dorv=`ls -1rt $vdir/$nam/$mach/ | tail -1l `
+    dorv=`echo $dorv | sed -e 's:.*/::'`
+    rep1=`ls -1rt $vdir/$nam/$mach/$dorv/ | tail -2l | head -1 `
+    rep2=`ls -1rt $vdir/$nam/$mach/$dorv/ | tail -1l`
+    cd ${SAS_RESTART_DIR}/LONG
+    #SF add here compilation of rebuild_tools to rebuild restart files, and add comparison of restart files
+    cd ${TOOLS_DIR}
+    ./maketools -n REBUILD_NEMO -m ${mach} > /dev/null 2>&1
+    cd ${TOOLS_DIR}/REBUILD_NEMO
+    #SF echo "REBUILD LONG restart SAS files, without standard output"
+    ./rebuild_nemo -t 4 ../../CONFIG/SAS_LONG/LONG/SAS_00000100_restart_ice  $NPROC > /dev/null 2>&1
+    #SF echo "REBUILD SHORT restart SAS files, without standard output"
+    ./rebuild_nemo -t 4 ../../CONFIG/SAS_LONG/SHORT/SAS_00000100_restart_ice $NPROC >&-
+    cd ${SAS_RESTART_DIR}/LONG
+    #SF echo "COPY rebuild restart files"
+    cp SAS_00000100_restart_ice.nc $vdir/$nam/$mach/$dorv/LONG/.
+    cp ../SHORT/SAS_00000100_restart_ice.nc $vdir/$nam/$mach/$dorv/SHORT/.
+
+    f1o=$vdir/$nam/$mach/$dorv/LONG/SAS_00000100_restart_ice.nc
+    f2o=$vdir/$nam/$mach/$dorv/SHORT/SAS_00000100_restart_ice.nc
+    if  [ ! -f $f1o ] &&  [ ! -f $f2o ] ; then
+      printf "%-20s %s\n" $nam " REBUILD SAS restart ice DOES NOT exists; incomplete test";
+      return;
+    fi
+    #
+    done_oce=0
+    #
+    if  [  -f $f1o ] && [  -f $f2o ]; then
+      cmp -s $f1o $f2o 
+      #SF  cmp SAS_00000100_restart_ice.nc  ../SHORT/SAS_00000100_restart_ice.nc  > diff_restart.txt
+      if [ $? == 0 ]; then
+        if [ $pass == 0 ]; then
+          printf "%-20s %s %s\n" $nam  " SAS restart files are IDENTICAL :  passed : " $dorv
+        fi
+      else
+        printf "%-20s %s %s\n" $nam  " SAS restart files are DIFFERENT : FAILED : " $dorv 
+        #
+	# Offer view of differences on the second pass
+	#
+        if [ $pass == 1 ]; then
+          echo "BE CAREFUL:  NEED cdo to see differences!!!!! IF it is not the case you need to do difference of netcdf file by hand"
+          echo "<return> to view restart_ice.nc differences"
+          read y
+          cdo -diffv $f1o $f2o
+          done_oce=1
+          #echo "<return> to continue"
+          #read y
+        fi
+      fi
+    fi
+#
+fi
+}
+
 function resttest() { 
 #
@@ -199,4 +265,13 @@
   mach=`grep "COMPILER=" ./sette.sh | sed -e 's/COMPILER=//'`
   NEMO_VALID=`grep "NEMO_VALIDATION_DIR=" ./param.cfg | sed -e 's/NEMO_VALIDATION_DIR=//'`
+# Directory to run the tests
+ SETTE_DIR=$(cd $(dirname "$0"); pwd)
+ MAIN_DIR=$(dirname $SETTE_DIR)
+ CONFIG_DIR0=${MAIN_DIR}/CONFIG
+ TOOLS_DIR=${MAIN_DIR}/TOOLS
+ COMPIL_DIR=${TOOLS_DIR}/COMPILE
+ NPROC=32
+
+  SAS_RESTART_DIR=${CONFIG_DIR0}/SAS_LONG
 #
   if [ ! -d $NEMO_VALID ]; then
@@ -205,4 +280,5 @@
   fi
 #
+
 # The script also needs the date or revision tag. Currently this is taken from the latest sub-directory found in each directory
 #  
@@ -212,7 +288,16 @@
  if [ $pass == 1 ]; then echo "---------------2nd pass------------------";fi
 #
+
+# Rebuild and restartability test for SAS
+#
+ for restart_file in WSAS_LONG
+ do
+ #  restfile $SAS_RESTART_DIR LONG $pass
+   restfile $NEMO_VALID $restart_file $pass
+ done
+#
 # Restartability test
 #
- for restart_test in WGYREPIS_LONG WORCA2LIM3PIS_LONG WORCA2OFFPIS_LONG WAMM12_LONG WSAS_LONG WISOMIP_LONG WORCA2AGUL_LONG
+ for restart_test in WGYREPIS_LONG WORCA2LIM3PIS_LONG WORCA2OFFPIS_LONG WAMM12_LONG WISOMIP_LONG WORCA2AGUL_LONG
  do
    resttest $NEMO_VALID $restart_test $pass